Index: uspace/lib/libc/arch/arm32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/arm32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/arm32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libcarm32
+/** @addtogroup libcarm32	
  * @{
  */
@@ -38,5 +38,5 @@
 
 #define LIBC_ARCH_ATOMIC_H_
-#define CAS
+#define CAS 
 
 #include <atomicdflt.h>
@@ -46,8 +46,8 @@
 extern uintptr_t *ras_page;
 
-static inline bool cas(atomic_t *val, atomic_count_t ov, atomic_count_t nv)
+static inline bool cas(atomic_t *val, long ov, long nv)
 {
-	atomic_count_t ret = 0;
-	
+	long ret = 0;
+
 	/*
 	 * The following instructions between labels 1 and 2 constitute a
@@ -75,11 +75,9 @@
 		: "memory"
 	);
-	
+
 	ras_page[0] = 0;
-	asm volatile (
-		"" ::: "memory"
-	);
+	asm volatile ("" ::: "memory");	
 	ras_page[1] = 0xffffffff;
-	
+
 	return (bool) ret;
 }
@@ -91,10 +89,9 @@
  *
  * @return Value after addition.
- *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+static inline long atomic_add(atomic_t *val, int i)
 {
-	atomic_count_t ret = 0;
-	
+	long ret = 0;
+
 	/*
 	 * The following instructions between labels 1 and 2 constitute a
@@ -118,11 +115,9 @@
 		: [imm] "r" (i)
 	);
-	
+
 	ras_page[0] = 0;
-	asm volatile (
-		"" ::: "memory"
-	);
+	asm volatile ("" ::: "memory");	
 	ras_page[1] = 0xffffffff;
-	
+
 	return ret;
 }
@@ -132,5 +127,4 @@
  *
  * @param val Variable to be incremented.
- *
  */
 static inline void atomic_inc(atomic_t *val)
@@ -143,5 +137,4 @@
  *
  * @param val Variable to be decremented.
- *
  */
 static inline void atomic_dec(atomic_t *val)
@@ -155,7 +148,6 @@
  * @param val Variable to be incremented.
  * @return    Value after incrementation.
- *
  */
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
 	return atomic_add(val, 1);
@@ -167,7 +159,6 @@
  * @param val Variable to be decremented.
  * @return    Value after decrementation.
- *
  */
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
 	return atomic_add(val, -1);
@@ -179,7 +170,6 @@
  * @param val Variable to be incremented.
  * @return    Value before incrementation.
- *
  */
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	return atomic_add(val, 1) - 1;
@@ -191,7 +181,6 @@
  * @param val Variable to be decremented.
  * @return    Value before decrementation.
- *
  */
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	return atomic_add(val, -1) + 1;
Index: uspace/lib/libc/arch/arm32/include/types.h
===================================================================
--- uspace/lib/libc/arch/arm32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/arm32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -55,6 +55,4 @@
 
 typedef uint32_t uintptr_t;
-typedef uint32_t atomic_count_t;
-typedef int32_t atomic_signed_t;
 
 #endif
Index: uspace/lib/libc/arch/ia32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ia32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/ia32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,28 +40,33 @@
 #include <atomicdflt.h>
 
-static inline void atomic_inc(atomic_t *val)
-{
-	asm volatile (
-		"lock incl %[count]\n"
-		: [count] "+m" (val->count)
-	);
+static inline void atomic_inc(atomic_t *val) {
+	asm volatile ("lock incl %0\n" : "+m" (val->count));
 }
 
-static inline void atomic_dec(atomic_t *val)
-{
-	asm volatile (
-		"lock decl %[count]\n"
-		: [count] "+m" (val->count)
-	);
+static inline void atomic_dec(atomic_t *val) {
+	asm volatile ("lock decl %0\n" : "+m" (val->count));
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val) 
 {
-	atomic_count_t r = 1;
+	long r;
+
+	asm volatile (
+		"movl $1, %0\n"
+		"lock xaddl %0, %1\n"
+		: "=r" (r), "+m" (val->count)
+	);
+
+	return r;
+}
+
+static inline long atomic_postdec(atomic_t *val) 
+{
+	long r;
 	
 	asm volatile (
-		"lock xaddl %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		"movl $-1, %0\n"
+		"lock xaddl %0, %1\n"
+		: "=r" (r), "+m" (val->count)
 	);
 	
@@ -69,19 +74,6 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
-{
-	atomic_count_t r = -1;
-	
-	asm volatile (
-		"lock xaddl %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
-	);
-	
-	return r;
-}
-
-#define atomic_preinc(val)  (atomic_postinc(val) + 1)
-#define atomic_predec(val)  (atomic_postdec(val) - 1)
+#define atomic_preinc(val) (atomic_postinc(val) + 1)
+#define atomic_predec(val) (atomic_postdec(val) - 1)
 
 #endif
Index: uspace/lib/libc/arch/ia32/include/types.h
===================================================================
--- uspace/lib/libc/arch/ia32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/ia32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,6 +54,4 @@
 
 typedef uint32_t uintptr_t;
-typedef uint32_t atomic_count_t;
-typedef int32_t atomic_signed_t;
 
 #endif
Index: uspace/lib/libc/arch/ia64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ia64/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/ia64/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -42,5 +42,5 @@
 static inline void atomic_inc(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -53,5 +53,5 @@
 static inline void atomic_dec(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -62,7 +62,7 @@
 }
 
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -75,7 +75,7 @@
 }
 
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -88,7 +88,7 @@
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -101,7 +101,7 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
Index: uspace/lib/libc/arch/ia64/include/types.h
===================================================================
--- uspace/lib/libc/arch/ia64/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/ia64/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -59,6 +59,4 @@
 
 typedef uint64_t uintptr_t;
-typedef uint64_t atomic_count_t;
-typedef int64_t atomic_signed_t;
 
 typedef struct {
Index: uspace/lib/libc/arch/mips32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/mips32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/mips32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,9 +27,9 @@
  */
 
-/** @addtogroup libcmips32
+/** @addtogroup libcmips32	
  * @{
  */
 /** @file
- * @ingroup libcmips32eb
+ * @ingroup libcmips32eb	
  */
 
@@ -41,26 +41,24 @@
 #include <atomicdflt.h>
 
-#define atomic_inc(x)  ((void) atomic_add(x, 1))
-#define atomic_dec(x)  ((void) atomic_add(x, -1))
+#define atomic_inc(x)	((void) atomic_add(x, 1))
+#define atomic_dec(x)	((void) atomic_add(x, -1))
 
-#define atomic_postinc(x)  (atomic_add(x, 1) - 1)
-#define atomic_postdec(x)  (atomic_add(x, -1) + 1)
+#define atomic_postinc(x) (atomic_add(x, 1) - 1)
+#define atomic_postdec(x) (atomic_add(x, -1) + 1)
 
-#define atomic_preinc(x)  atomic_add(x, 1)
-#define atomic_predec(x)  atomic_add(x, -1)
+#define atomic_preinc(x) atomic_add(x, 1)
+#define atomic_predec(x) atomic_add(x, -1)
 
 /* Atomic addition of immediate value.
  *
  * @param val Memory location to which will be the immediate value added.
- * @param i   Signed immediate that will be added to *val.
+ * @param i Signed immediate that will be added to *val.
  *
  * @return Value after addition.
- *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+static inline long atomic_add(atomic_t *val, int i)
 {
-	atomic_count_t tmp;
-	atomic_count_t v;
-	
+	long tmp, v;
+
 	asm volatile (
 		"1:\n"
@@ -72,11 +70,8 @@
 		/*	nop	*/		/* nop is inserted automatically by compiler */
 		"	nop\n"
-		: "=&r" (tmp),
-		  "+m" (val->count),
-		  "=&r" (v)
-		: "r" (i),
-		  "i" (0)
-	);
-	
+		: "=&r" (tmp), "+m" (val->count), "=&r" (v)
+		: "r" (i), "i" (0)
+		);
+
 	return v;
 }
Index: uspace/lib/libc/arch/mips32/include/types.h
===================================================================
--- uspace/lib/libc/arch/mips32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/mips32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libcmips32
+/** @addtogroup libcmips32	
  * @{
  */
@@ -55,6 +55,4 @@
 
 typedef uint32_t uintptr_t;
-typedef uint32_t atomic_count_t;
-typedef int32_t atomic_signed_t;
 
 #endif
Index: uspace/lib/libc/arch/ppc32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ppc32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/ppc32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libcppc32
+/** @addtogroup libcppc32	
  * @{
  */
@@ -42,6 +42,6 @@
 static inline void atomic_inc(atomic_t *val)
 {
-	atomic_count_t tmp;
-	
+	long tmp;
+
 	asm volatile (
 		"1:\n"
@@ -50,31 +50,25 @@
 		"stwcx. %0, 0, %2\n"
 		"bne- 1b"
-		: "=&r" (tmp),
-		  "=m" (val->count)
-		: "r" (&val->count),
-		  "m" (val->count)
-		: "cc"
-	);
+		: "=&r" (tmp), "=m" (val->count)
+		: "r" (&val->count), "m" (val->count)
+		: "cc");
 }
 
 static inline void atomic_dec(atomic_t *val)
 {
-	atomic_count_t tmp;
-	
+	long tmp;
+
 	asm volatile (
 		"1:\n"
 		"lwarx %0, 0, %2\n"
 		"addic %0, %0, -1\n"
-		"stwcx. %0, 0, %2\n"
+		"stwcx.	%0, 0, %2\n"
 		"bne- 1b"
-		: "=&r" (tmp),
-		  "=m" (val->count)
-		: "r" (&val->count),
-		  "m" (val->count)
-		: "cc"
-	);
+		: "=&r" (tmp), "=m" (val->count)
+		: "r" (&val->count), "m" (val->count)
+		: "cc");
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	atomic_inc(val);
@@ -82,5 +76,5 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	atomic_dec(val);
@@ -88,5 +82,5 @@
 }
 
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
 	atomic_inc(val);
@@ -94,5 +88,5 @@
 }
 
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
 	atomic_dec(val);
Index: uspace/lib/libc/arch/ppc32/include/types.h
===================================================================
--- uspace/lib/libc/arch/ppc32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/ppc32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libcppc32
+/** @addtogroup libcppc32	
  * @{
  */
@@ -54,6 +54,4 @@
 
 typedef uint32_t uintptr_t;
-typedef uint32_t atomic_count_t;
-typedef int32_t atomic_signed_t;
 
 #endif
Index: uspace/lib/libc/arch/sparc64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/sparc64/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/sparc64/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -46,47 +46,39 @@
  *
  * @param val Atomic variable.
- * @param i   Signed value to be added.
+ * @param i Signed value to be added.
  *
  * @return Value of the atomic variable as it existed before addition.
- *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+static inline long atomic_add(atomic_t *val, int i)
 {
-	atomic_count_t a;
-	atomic_count_t b;
-	
+	uint64_t a, b;
+
 	do {
-		volatile uintptr_t ptr = (uintptr_t) &val->count;
-		
-		a = *((atomic_count_t *) ptr);
+		volatile uintptr_t x = (uint64_t) &val->count;
+
+		a = *((uint64_t *) x);
 		b = a + i;
-		
-		asm volatile (
-			"casx %0, %2, %1\n"
-			: "+m" (*((atomic_count_t *) ptr)),
-			  "+r" (b)
-			: "r" (a)
-		);
+		asm volatile ("casx %0, %2, %1\n" : "+m" (*((uint64_t *)x)), "+r" (b) : "r" (a));
 	} while (a != b);
-	
+
 	return a;
 }
 
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
 	return atomic_add(val, 1) + 1;
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	return atomic_add(val, 1);
 }
 
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
 	return atomic_add(val, -1) - 1;
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	return atomic_add(val, -1);
Index: uspace/lib/libc/arch/sparc64/include/types.h
===================================================================
--- uspace/lib/libc/arch/sparc64/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/arch/sparc64/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,6 +54,4 @@
 
 typedef uint64_t uintptr_t;
-typedef uint64_t atomic_count_t;
-typedef int64_t atomic_signed_t;
 
 #endif
Index: uspace/lib/libc/generic/async.c
===================================================================
--- uspace/lib/libc/generic/async.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/async.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -1101,58 +1101,4 @@
 }
 
-/** Wrapper for making IPC_M_CONNECT_ME_TO calls using the async framework.
- * 
- * Ask through phone for a new connection to some service.
- *
- * @param phoneid	Phone handle used for contacting the other side.
- * @param arg1		User defined argument.
- * @param arg2		User defined argument.
- * @param arg3		User defined argument.
- *
- * @return		New phone handle on success or a negative error code.
- */
-int
-async_connect_me_to(int phoneid, ipcarg_t arg1, ipcarg_t arg2, ipcarg_t arg3)
-{
-	int rc;
-	ipcarg_t newphid;
-
-	rc = async_req_3_5(phoneid, IPC_M_CONNECT_ME_TO, arg1, arg2, arg3, NULL,
-	    NULL, NULL, NULL, &newphid);
-	
-	if (rc != EOK)	
-		return rc;
-
-	return newphid;
-}
-
-/** Wrapper for making IPC_M_CONNECT_ME_TO calls using the async framework.
- * 
- * Ask through phone for a new connection to some service and block until
- * success.
- *
- * @param phoneid	Phone handle used for contacting the other side.
- * @param arg1		User defined argument.
- * @param arg2		User defined argument.
- * @param arg3		User defined argument.
- *
- * @return		New phone handle on success or a negative error code.
- */
-int
-async_connect_me_to_blocking(int phoneid, ipcarg_t arg1, ipcarg_t arg2,
-    ipcarg_t arg3)
-{
-	int rc;
-	ipcarg_t newphid;
-
-	rc = async_req_4_5(phoneid, IPC_M_CONNECT_ME_TO, arg1, arg2, arg3,
-	    IPC_FLAG_BLOCKING, NULL, NULL, NULL, NULL, &newphid);
-	
-	if (rc != EOK)	
-		return rc;
-
-	return newphid;
-}
-
 /** Wrapper for making IPC_M_SHARE_IN calls using the async framework.
  *
Index: uspace/lib/libc/generic/futex.c
===================================================================
--- uspace/lib/libc/generic/futex.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/futex.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -68,5 +68,5 @@
 int futex_down(futex_t *futex)
 {
-	if ((atomic_signed_t) atomic_predec(futex) < 0)
+	if (atomic_predec(futex) < 0)
 		return __SYSCALL1(SYS_FUTEX_SLEEP, (sysarg_t) &futex->count);
 
@@ -82,5 +82,5 @@
 int futex_up(futex_t *futex)
 {
-	if ((atomic_signed_t) atomic_postinc(futex) < 0)
+	if (atomic_postinc(futex) < 0)
 		return __SYSCALL1(SYS_FUTEX_WAKEUP, (sysarg_t) &futex->count);
 		
Index: uspace/lib/libc/generic/io/io.c
===================================================================
--- uspace/lib/libc/generic/io/io.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/io/io.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -536,31 +536,4 @@
 }
 
-char *fgets(char *str, int size, FILE *stream)
-{
-	int c;
-	int idx;
-
-	idx = 0;
-	while (idx < size - 1) {
-		c = fgetc(stream);
-		if (c == EOF)
-			break;
-
-		str[idx++] = c;
-
-		if (c == '\n')
-			break;
-	}
-
-	if (ferror(stream))
-		return NULL;
-
-	if (idx == 0)
-		return NULL;
-
-	str[idx] = '\0';
-	return str;
-}
-
 int getchar(void)
 {
Index: uspace/lib/libc/generic/loader.c
===================================================================
--- uspace/lib/libc/generic/loader.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/loader.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -183,5 +183,5 @@
  *
  */
-int loader_set_args(loader_t *ldr, const char *const argv[])
+int loader_set_args(loader_t *ldr, char *const argv[])
 {
 	/*
@@ -189,5 +189,5 @@
 	 * compute size of the buffer needed.
 	 */
-	const char *const *ap = argv;
+	char *const *ap = argv;
 	size_t buffer_size = 0;
 	while (*ap != NULL) {
Index: uspace/lib/libc/generic/sysinfo.c
===================================================================
--- uspace/lib/libc/generic/sysinfo.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/sysinfo.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -37,7 +37,7 @@
 #include <string.h>
 
-sysarg_t sysinfo_value(const char *name)
+sysarg_t sysinfo_value(char *name)
 {
-	return __SYSCALL2(SYS_SYSINFO_VALUE, (sysarg_t) name,
+	return __SYSCALL2(SYS_SYSINFO_VALUE, (sysarg_t ) name,
 	    (sysarg_t) str_size(name));
 }
Index: uspace/lib/libc/generic/task.c
===================================================================
--- uspace/lib/libc/generic/task.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/task.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -76,5 +76,5 @@
  *
  */
-task_id_t task_spawn(const char *path, const char *const args[])
+task_id_t task_spawn(const char *path, char *const args[])
 {
 	/* Connect to a program loader. */
Index: uspace/lib/libc/generic/thread.c
===================================================================
--- uspace/lib/libc/generic/thread.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/generic/thread.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -86,5 +86,5 @@
  * @return Zero on success or a code from @ref errno.h on failure.
  */
-int thread_create(void (* function)(void *), void *arg, const char *name,
+int thread_create(void (* function)(void *), void *arg, char *name,
     thread_id_t *tid)
 {
Index: uspace/lib/libc/include/async.h
===================================================================
--- uspace/lib/libc/include/async.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/async.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -259,7 +259,4 @@
 }
 
-extern int async_connect_me_to(int, ipcarg_t, ipcarg_t, ipcarg_t);
-extern int async_connect_me_to_blocking(int, ipcarg_t, ipcarg_t, ipcarg_t);
-
 /*
  * User-friendly wrappers for async_share_in_start().
Index: uspace/lib/libc/include/atomicdflt.h
===================================================================
--- uspace/lib/libc/include/atomicdflt.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/atomicdflt.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -37,26 +37,25 @@
 
 #ifndef LIBC_ARCH_ATOMIC_H_
-	#error This file cannot be included directly, include atomic.h instead.
+#error This file cannot be included directly, include atomic.h instead.
 #endif
 
-#include <stdint.h>
 #include <bool.h>
 
 typedef struct atomic {
-	volatile atomic_count_t count;
+	volatile long count;
 } atomic_t;
 
-static inline void atomic_set(atomic_t *val, atomic_count_t i)
+static inline void atomic_set(atomic_t *val, long i)
 {
-	val->count = i;
+        val->count = i;
 }
 
-static inline atomic_count_t atomic_get(atomic_t *val)
+static inline long atomic_get(atomic_t *val)
 {
-	return val->count;
+        return val->count;
 }
 
 #ifndef CAS
-static inline bool cas(atomic_t *val, atomic_count_t ov, atomic_count_t nv)
+static inline bool cas(atomic_t *val, long ov, long nv)
 {
 	return __sync_bool_compare_and_swap(&val->count, ov, nv);
Index: uspace/lib/libc/include/loader/loader.h
===================================================================
--- uspace/lib/libc/include/loader/loader.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/loader/loader.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -51,5 +51,5 @@
 extern int loader_set_cwd(loader_t *);
 extern int loader_set_pathname(loader_t *, const char *);
-extern int loader_set_args(loader_t *, const char *const[]);
+extern int loader_set_args(loader_t *, char *const[]);
 extern int loader_set_files(loader_t *, fdi_node_t *const[]);
 extern int loader_load_program(loader_t *);
Index: uspace/lib/libc/include/stdio.h
===================================================================
--- uspace/lib/libc/include/stdio.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/stdio.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -110,5 +110,5 @@
 /* Character and string input functions */
 extern int fgetc(FILE *);
-extern char *fgets(char *, int, FILE *);
+extern char *fgets(char *, size_t, FILE *);
 
 extern int getchar(void);
Index: uspace/lib/libc/include/sysinfo.h
===================================================================
--- uspace/lib/libc/include/sysinfo.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/sysinfo.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,5 +40,5 @@
 #include <string.h>
 
-sysarg_t sysinfo_value(const char *name);
+sysarg_t sysinfo_value(char *name);
 
 #endif
Index: uspace/lib/libc/include/task.h
===================================================================
--- uspace/lib/libc/include/task.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/task.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -47,5 +47,5 @@
 extern task_id_t task_get_id(void);
 extern int task_set_name(const char *name);
-extern task_id_t task_spawn(const char *path, const char *const argv[]);
+extern task_id_t task_spawn(const char *path, char *const argv[]);
 extern int task_wait(task_id_t id, task_exit_t *texit, int *retval);
 extern int task_retval(int val);
Index: uspace/lib/libc/include/thread.h
===================================================================
--- uspace/lib/libc/include/thread.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libc/include/thread.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -45,5 +45,5 @@
 extern void __thread_main(uspace_arg_t *);
 
-extern int thread_create(void (*)(void *), void *, const char *, thread_id_t *);
+extern int thread_create(void (*)(void *), void *, char *, thread_id_t *);
 extern void thread_exit(int) __attribute__ ((noreturn));
 extern void thread_detach(thread_id_t);
Index: uspace/lib/libpci/access.c
===================================================================
--- uspace/lib/libpci/access.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libpci/access.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -51,5 +51,5 @@
 }
 
-static void pci_generic_error(const char *msg, ...)
+static void pci_generic_error(char *msg, ...)
 {
 	va_list args;
@@ -62,5 +62,5 @@
 }
 
-static void pci_generic_warn(const char *msg, ...)
+static void pci_generic_warn(char *msg, ...)
 {
 	va_list args;
@@ -72,5 +72,5 @@
 }
 
-static void pci_generic_debug(const char *msg, ...)
+static void pci_generic_debug(char *msg, ...)
 {
 	va_list args;
@@ -81,5 +81,5 @@
 }
 
-static void pci_null_debug(const char *msg UNUSED, ...)
+static void pci_null_debug(char *msg UNUSED, ...)
 {
 }
Index: uspace/lib/libpci/internal.h
===================================================================
--- uspace/lib/libpci/internal.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libpci/internal.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -13,5 +13,5 @@
 
 struct pci_methods {
-	const char *name;
+	char *name;
 	void (*config) (struct pci_access *);
 	int (*detect) (struct pci_access *);
Index: uspace/lib/libpci/names.c
===================================================================
--- uspace/lib/libpci/names.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libpci/names.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -299,5 +299,5 @@
 }
 
-const char *pci_lookup_name(struct pci_access *a, char *buf, int size, int flags,
+char *pci_lookup_name(struct pci_access *a, char *buf, int size, int flags,
 		      ...)
 {
Index: uspace/lib/libpci/pci.h
===================================================================
--- uspace/lib/libpci/pci.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/lib/libpci/pci.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,7 +40,7 @@
 
 	/* Functions you can override: */
-	void (*error) (const char *msg, ...);	/* Write error message and quit */
-	void (*warning) (const char *msg, ...);	/* Write a warning message */
-	void (*debug) (const char *msg, ...);	/* Write a debugging message */
+	void (*error) (char *msg, ...);	/* Write error message and quit */
+	void (*warning) (char *msg, ...);	/* Write a warning message */
+	void (*debug) (char *msg, ...);	/* Write a debugging message */
 
 	struct pci_dev *devices;	/* Devices found on this bus */
@@ -128,6 +128,6 @@
  */
 
-const char *pci_lookup_name(struct pci_access *a, char *buf, int size,
-    int flags, ...);
+char *pci_lookup_name(struct pci_access *a, char *buf, int size, int flags,
+		      ...);
 
 int pci_load_name_list(struct pci_access *a);	/* Called automatically by pci_lookup_*() when needed; returns success */
Index: uspace/srv/hid/adb_mouse/adb_dev.c
===================================================================
--- uspace/srv/hid/adb_mouse/adb_dev.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/hid/adb_mouse/adb_dev.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -50,5 +50,5 @@
 int adb_dev_init(void)
 {
-	const char *input = "/dev/adb/mouse";
+	char *input = "/dev/adb/mouse";
 	int input_fd;
 
Index: uspace/srv/hid/char_mouse/chardev.c
===================================================================
--- uspace/srv/hid/char_mouse/chardev.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/hid/char_mouse/chardev.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -52,5 +52,5 @@
 int mouse_port_init(void)
 {
-	const char *input = "/dev/char/ps2b";
+	char *input = "/dev/char/ps2b";
 	int input_fd;
 
Index: uspace/srv/hid/fb/serial_console.c
===================================================================
--- uspace/srv/hid/fb/serial_console.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/hid/fb/serial_console.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -100,5 +100,5 @@
 };
 
-void serial_puts(const char *str)
+void serial_puts(char *str)
 {
 	while (*str)
Index: uspace/srv/hid/fb/serial_console.h
===================================================================
--- uspace/srv/hid/fb/serial_console.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/hid/fb/serial_console.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -43,5 +43,5 @@
 typedef void (*putc_function_t)(char);
 
-void serial_puts(const char *str);
+void serial_puts(char *str);
 void serial_goto(const unsigned int col, const unsigned int row);
 void serial_clrscr(void);
Index: uspace/srv/hid/kbd/port/adb.c
===================================================================
--- uspace/srv/hid/kbd/port/adb.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/hid/kbd/port/adb.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -53,5 +53,5 @@
 int kbd_port_init(void)
 {
-	const char *input = "/dev/adb/kbd";
+	char *input = "/dev/adb/kbd";
 	int input_fd;
 
Index: uspace/srv/hid/kbd/port/chardev.c
===================================================================
--- uspace/srv/hid/kbd/port/chardev.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/hid/kbd/port/chardev.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -52,5 +52,5 @@
 int kbd_port_init(void)
 {
-	const char *input = "/dev/char/ps2a";
+	char *input = "/dev/char/ps2a";
 	int input_fd;
 
Index: uspace/srv/loader/elf_load.c
===================================================================
--- uspace/srv/loader/elf_load.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/loader/elf_load.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -60,5 +60,5 @@
 #define DPRINTF(...)
 
-static const char *error_codes[] = {
+static char *error_codes[] = {
 	"no error",
 	"invalid image",
@@ -95,13 +95,12 @@
  * pointed to by @a info.
  *
- * @param file_name Path to the ELF file.
- * @param so_bias   Bias to use if the file is a shared object.
- * @param info      Pointer to a structure for storing information
- *                  extracted from the binary.
+ * @param file_name	Path to the ELF file.
+ * @param so_bias	Bias to use if the file is a shared object.
+ * @param info		Pointer to a structure for storing information
+ *			extracted from the binary.
  *
  * @return EOK on success or negative error code.
- *
- */
-int elf_load_file(const char *file_name, size_t so_bias, elf_info_t *info)
+ */
+int elf_load_file(char *file_name, size_t so_bias, elf_info_t *info)
 {
 	elf_ld_t elf;
@@ -131,6 +130,5 @@
  * earlier with elf_load_file(). This function does not return.
  *
- * @param info Info structure filled earlier by elf_load_file()
- *
+ * @param info	Info structure filled earlier by elf_load_file()
  */
 void elf_run(elf_info_t *info, pcb_t *pcb)
@@ -282,5 +280,5 @@
  * @return NULL terminated description of error.
  */
-const char *elf_error(unsigned int rc)
+char *elf_error(unsigned int rc)
 {
 	assert(rc < sizeof(error_codes) / sizeof(char *));
Index: uspace/srv/loader/include/elf.h
===================================================================
--- uspace/srv/loader/include/elf.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/srv/loader/include/elf.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -337,5 +337,5 @@
 #endif
 
-extern const char *elf_error(unsigned int rc);
+extern char *elf_error(unsigned int rc);
 
 #endif
